#if defined(WIN32)
#  include "glut.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

#include "box.h"

/*
** Ȣ
*/
void box(double x, double y, double z)
{
  /* ĺκɸ */
  const GLdouble vertex[][4][3] = {
    {{ -x, -y, -z }, {  x, -y, -z }, {  x, -y,  z }, { -x, -y,  z }}, /*  */
    {{  x, -y, -z }, { -x, -y, -z }, { -x,  y, -z }, {  x,  y, -z }}, /* ΢ */
    {{  x, -y,  z }, {  x, -y, -z }, {  x,  y, -z }, {  x,  y,  z }}, /*  */
    {{ -x, -y,  z }, {  x, -y,  z }, {  x,  y,  z }, { -x,  y,  z }}, /*  */
    {{ -x, -y, -z }, { -x, -y,  z }, { -x,  y,  z }, { -x,  y, -z }}, /*  */
    {{ -x,  y,  z }, {  x,  y,  z }, {  x,  y, -z }, { -x,  y, -z }}, /*  */
  };
  
  /* ĺΥƥɸ */
  static const GLdouble texcoord[][4][2] = {
    {{ 0.0,   1.0 }, { 0.125, 1.0 }, { 0.125, 0.0 }, { 0.0,   0.0 }},
    {{ 0.125, 1.0 }, { 0.25,  1.0 }, { 0.25,  0.0 }, { 0.125, 0.0 }},
    {{ 0.25,  1.0 }, { 0.375, 1.0 }, { 0.375, 0.0 }, { 0.25,  0.0 }},
    {{ 0.375, 1.0 }, { 0.5,   1.0 }, { 0.5,   0.0 }, { 0.375, 0.0 }},
    {{ 0.5,   1.0 }, { 0.625, 1.0 }, { 0.625, 0.0 }, { 0.5,   0.0 }},
    {{ 0.625, 1.0 }, { 0.75,  1.0 }, { 0.75,  0.0 }, { 0.625, 0.0 }},
  };
  
  /* ̤ˡ٥ȥ */
  static const GLdouble normal[][3] = {
    {  0.0, -1.0,  0.0 },
    {  0.0,  0.0, -1.0 },
    {  1.0,  0.0,  0.0 },
    {  0.0,  0.0,  1.0 },
    { -1.0,  0.0,  0.0 },
    {  0.0,  1.0,  0.0 },
  };
  
  int i, j;
  
  /* ͳѷȢ */
  glBegin(GL_QUADS);
  for (j = 0; j < 6; ++j) {
    glNormal3dv(normal[j]);
    for (i = 0; i < 4; ++i) {
      /* ƥɸλ */
      glTexCoord2dv(texcoord[j][i]);
      /* бĺɸλ */
      glVertex3dv(vertex[j][i]);
    }
  }
  glEnd();
}
